
import java.util.*;

public class Box {
	private int boxId;
	private Stable stable; //Kompozycja - cz - liczno 1
	private Horse horse = null; //Asocjacja binarna - liczno 0..1
	
	private static int counter = 0;
	private static List<Box> boxes = new ArrayList<Box>(); //Ekstensja
	
	public Box(Stable stable) throws Exception{
		if(stable == null || !Stable.getStables().contains(stable))
			throw new Exception("new Box(Stable): stable cannot be null");
		counter++;
		setId(counter);
		setHorse(null);
		setStable(stable);
		boxes.add(this);
		
	}
	public Box(Stable stable, Horse horse) throws Exception{
		if(stable == null || !Stable.getStables().contains(stable))
			throw new Exception("new Box(Stable): stable cannot be null");
		counter++;
		setId(counter);
		if(horse.getBox() != null) //Oznacz stary boks tego konia jako pusty
			horse.getBox().setHorse(null);
		setHorse(horse);
		setStable(stable);
		boxes.add(this);
	}
	
	//Ustawianie i odczytywanie atrybutw
	public int getId(){
		return this.boxId;
	}
	private void setId(int id){
		this.boxId = id;
	}
	public Horse getHorse(){
		return this.horse;
	}
	public void setHorse(Horse horse){
		if(horse == null) return;
		this.horse = horse;
		if(horse.getBox() != this){
			horse.setBox(this);
		}
	}
	
	//Obsuga ekstensji
	public static List<Box> getBoxes(){
		return boxes;
	}
	public static boolean removeBox(Box box) throws Exception{
		if(box == null || !boxes.contains(box))
			return false;
		if(box.getHorse() != null)
			throw new Exception("Nie mona usun boksu zajtego przez konia: " + box.getHorse().toString());
		if(box.getStable().hasBox(box)){
			boxes.remove(box);
			box.getStable().removeBox(box);
			return true;
		}
		return false;
	}
	
	//Obsuga asocjacji
	private void setStable(Stable stable){
		this.stable = stable;
		stable.addBox(this);
	}
	public Stable getStable(){
		return this.stable;
	}
	
	//Przeciona metoda toString
	public String toString(){
		return "Boks o nr " + getId() + " ze stajni " + getStable().getName();
	}
}
