import java.util.*;

public class Group {
	private int groupId;
	private String groupName;
	
	private static ArrayList<Group> groups = new ArrayList<Group>(); //Ekstensja
	
	private Map<Integer, Rider> riders; //Asocjacja kwalifikowana - liczno *
 	
	//Konstruktor
	public Group(int id, String name){
		setId(id);
		setName(name);
		this.riders = new HashMap<Integer, Rider>();
		groups.add(this);
	}
	
	//Ustawianie i odczytywanie atrybutw
	public int getId(){
		return this.groupId;
	}
	private void setId(int id){
		this.groupId = id;
	}
	public String getName(){
		return this.groupName;
	}
	public void setName(String name){
		this.groupName = name;
	}
	
	//Obsuga ekstensji
	public static ArrayList<Group> getGroups(){
		return groups;
	}
	public static boolean removeGroup(Group group){
		return groups.remove(group);
	}

	//Obsuga asocjacji kwalifikowanej
	public Map<Integer, Rider> getRiders(){
		return this.riders;
	}
	public void addRider(Rider rider){
		if(!this.riders.containsKey(rider.getId())){
			this.riders.put(rider.getId(), rider);
			rider.changeGroup(this);
		}
	}
	public void removeRider(Rider rider){
		if(this.riders.containsKey(rider.getId())){
			this.riders.remove(rider.getId());
			if(rider.getGroup() == this)
				rider.changeGroup(null);
		}
	}
	public Rider findRider(int id) throws Exception{
		if(this.riders.containsKey(id))
			return this.riders.get(id);
		else
			throw new Exception("Nie ma takiego jedca w tej grupie");
	}
}
