import java.util.Calendar;


public class Main {

	public static void main(String[] args) {
		/* Tworzenie przykadowych stajni, boksw, koni, jedcw i grup
		Asocjacja Box-Stable to kompozycja,
		Asocjacja Horse-Box to asocjacja binarna o licznociach 1 i 0..1,
		Asocjacja Ko-Jedziec to asocjacja z atrybutem,
		Asocjacja Jedziec-Grupa to asocjacja kwalifikowana */
		
		Stable stable1, stable2, stable3 = null;
		Box b1, b2, b3, b4, b5;
		Horse h1, h2, h3, h4;
		Rider r1, r2, r3;
		Group g1, g2;
		HorseRiderPair p1, p2, p3;
		
		stable1 = new Stable("Szmaragdowa");
		stable2 = new Stable("Rubinowa");
		
		try{
			b1 = new Box(stable1); //Asocjacja binarna - liczno 0..1 - mona utworzy boks bez konia
			b2 = new Box(stable1);
			b3 = new Box(stable2);
			
			try{
				b4 = new Box(stable3); //Kompozycja - cz nie moe istnie bez caoci
			} catch(Exception e){
				System.out.println("Wyjtek: Kompozycja: cz nie moe istnie bez caoci.");
			}
			
			//Kompozycja - usuwanie czci w momencie usunicia caoci
			System.out.println("\nKompozycja: usuwanie czci w momencie usunicia caoci.");
			//Ekstensja klasy Box przed usuniciem stajni Rubinowa
			for(Box b : Box.getBoxes())
				System.out.println(b); //Kompozycja: cz naley do konkretnej caoci, nie moe by wspdzielona
			//Usuwanie stajni Rubinowa
			if(Stable.removeStable(stable2))
				System.out.println("Stajnia Rubinowa usunita.");
			//Ekstensja klasy Box po usuniciu stajni Rubinowa
			for(Box b : Box.getBoxes())
				System.out.println(b);
			System.out.println();
			
			stable3 = new Stable("Bursztynowa");
			h1 = new Horse("Hatatitla", b1);
			h2 = new Horse("Ilczi", b2);
			b4 = new Box(stable3, h2);
			b5 = new Box(stable3);
			h3 = new Horse("Juka", b2);
			try{
				h4 = new Horse("Broadway", b3); //Asocjacja binarna - liczno 1
			} catch(Exception e){
				System.out.println("Wyjtek: Asocjacja binarna - nie mona utworzy konia bez istniejcego boksa");
			}
			
			//Asocjacja kwalifikowana - kwalifikator rider.riderId
			g1 = new Group(10, "Zielona");
			g2 = new Group(20, "Niebieska");
			r1 = new Rider("Arthur", g1);
			r2 = new Rider("Suzy", g2);
			r3 = new Rider("Henry");
			g2.addRider(r2);
			r2.changeGroup(g1);
			System.out.println("Szukanie Suzy w grupie zielonej: " + g1.findRider(r2.getId()).toString());
			System.out.println();
			
			//Asocjacja z atrybutem
			Calendar c = Calendar.getInstance();
			r1.addHorse(h1, c);
			h2.addRider(r3);
			c.set(Calendar.MONTH, 2);
			r2.addHorse(h1, c, Calendar.getInstance());
			c.set(Calendar.MONTH, 7);
			c.set(Calendar.DAY_OF_MONTH, 25);
			r2.addHorse(h3, Calendar.getInstance(), c);
			System.out.println("Asocjacja z atrybutem - wszystkie powizania");
			for(HorseRiderPair pair : HorseRiderPair.getPairs()){
				System.out.println(pair);
			}
			
		} catch(Exception e){
			e.printStackTrace();
		}
		
		
		
	}

}
