import java.util.*;


public class Rider {
	private static int counter = 0;
	private static ArrayList<Rider> riders = new ArrayList<Rider>(); //Ekstensja
	
	private int riderId;
	private String name;
	private Group group; //Asocjacja kwalifikowana - liczno 1
	
	//Konstruktory
	public Rider(String name){
		counter++;
		setName(name);
		setId(counter);
		this.group = null;
		riders.add(this);
	}
	public Rider(String name, Group group){
		counter++;
		setName(name);
		setId(counter);
		this.group = group;
		riders.add(this);
	}
	
	//Ustawianie i odczytywanie wartoci atrybutw
	public int getId(){
		return this.riderId;
	}
	private void setId(int id){
		this.riderId = id;
	}
	
	public String getName(){
		return this.name;
	}
	public void setName(String name){
		this.name = name;
	}

	
	//Obsuga ekstensji
	public static ArrayList<Rider> getRiders(){
		return riders;
	}
	public static void removeRider(Rider rider){
		riders.remove(rider);
		for(HorseRiderPair pair : rider.getPairs()){
			HorseRiderPair.removePair(pair);
		}
	}
	
	//Asocjacji z atrybutem HorseRiderPair
	public Set<HorseRiderPair> getPairs(){
		return HorseRiderPair.getPairs(this);
	}
	public Set<Horse> getHorses(){
		return HorseRiderPair.getHorses(getPairs());
	}
	public boolean addHorse(Horse horse){
		try{
			HorseRiderPair.addPair(horse, this);
			return true;
		}catch(Exception e){
			return false;
		}
	}
	public boolean addHorse(Horse horse, Calendar from){
		try{
			HorseRiderPair.addPair(horse, this, from);
			return true;
		}catch(Exception e){
			return false;
		}
	}
	public boolean addHorse(Horse horse, Calendar from, Calendar to){
		try{
			HorseRiderPair.addPair(horse, this, from, to);
			return true;
		}catch(Exception e){
			return false;
		}
	}
	public void removeAllCurrentPairs(){
		for(HorseRiderPair pair : HorseRiderPair.getCurrentPairs(this)){
			HorseRiderPair.removePair(pair);
		}
	}
	
	//Obsuga asocjacji kwalifikowanej
	public Group getGroup(){
		return this.group;
	}
	
	public void changeGroup(Group group){
		if(this.group == null){
			group.addRider(this);
			this.group = group;
		}
		else if(group == null){
			this.group.removeRider(this);
			this.group = null;
		}
		else if(this.group != group){
			this.group.removeRider(this);
			group.addRider(this);
			this.group = group;
		}
	}
	
	//Przeciona metoda toString
	public String toString(){
		return "Jedziec o imieniu " + this.getName();
	}
}
