import java.util.*;

public class Stable {

	private String name;
	private List<Box> boxes; //Kompozycja - cao - liczno *
	
	private static ArrayList<Stable> stables = new ArrayList<Stable>(); //Ekstensja
	
	//Konstruktor
	public Stable(String name){
		setName(name);
		this.boxes = new ArrayList<Box>();
		stables.add(this);
	}
	
	//Ustawianie i odczytywanie atrybutw
	public String getName(){
		return this.name;
	}
	private void setName(String name){
		this.name = name;
	}
	
	//Obsuga ekstensji
	public static List<Stable> getStables(){
		return stables;
	}
	public static boolean removeStable(Stable stable) throws Exception{
		if(!stables.contains(stable))
			return false;
		List<Box> boxesCopy = new ArrayList<Box>();
		for(Box box : stable.getBoxes()){
			boxesCopy.add(box);
		}
		for(Box box : boxesCopy){
			stable.removeBox(box);
		}
		return stables.remove(stable);
	}
	
	//Obsuga kompozycji
	public List<Box> getBoxes(){
		return this.boxes;
	}
	public void addBox(Box box){
		if(!boxes.contains(box))
			this.boxes.add(box);
		
	}
	public boolean removeBox(Box box) throws Exception{
		if(box != null && hasBox(box)){
			Box.removeBox(box);
			this.boxes.remove(box);
			return true;
		}
		return false;
	}
	public boolean hasBox(Box box){
		return this.boxes.contains(box);
	}
	
	//Przeciona metoda toString
	public String toString(){
		return "Stajnia o nazwie " + getName();
	}
}
