import helpers.HorseGender;
import helpers.IJumping;
import helpers.PersonType;


public class Main {

	public static void main(String[] args) {
		//Przykadowe osoby
		/*Dziedziczenie overlapping i dynamic - to, czy osoba jest jedcem i/lub czy jest trenerem moe zmienia si w czasie
		Person <---- Rider
		Person <---- Trainer
		Implementacja z wykorzystaniem kompozycji
		*/Person p1 = new Person("Garth", "Nix", PersonType.RIDER);
		Person p2 = new Person("Neil", "Gaiman", PersonType.RIDER_TRAINER); //overlapping
		p1.becomeTrainer(); //dynamic
		p2.stopBeingTrainer(); //dynamic
		Person p3 = new Person("Arthur", "Penhaligon", PersonType.TRAINER);
		
		//Przykadowe konie
		/*Dziedziczenie wieloaspektowe i disjoint:
		Horse <--gender-- {Stallion, Mare, Gelding}
		Horse <--sport-- {JumpingHorse, DressageHorse}
		Dziedziczenie wielokrotne:
		JumpingHorse <---- EventingHorse (implementacja przy pomocy interfejsu IJumping)
		DressageHorse <---- EventingHorse (mechanizm dziedziczenia jzyka Java)
		Klasa abstrakcyjna: Gender
		Polimorficzne woanie metody:
		train() w klasach Horse, JumpingHorse, DressageHorse, EventingHorse
		*/
		Horse h1 = new Horse("Nil-chi", HorseGender.MARE);
		IJumping h2 = new JumpingHorse("Broadway");
		Horse h3 = new DressageHorse("Hatatitla", HorseGender.STALLION);
		IJumping h4 = new EventingHorse("Spirit", HorseGender.STALLION);
		h1.train();
		h2.train();
		h3.train();
		h4.train();
		
		p1.addHorseToRide(h1);
		p1.addHorseToTrain(h3);
		p1.rideHorse(h1);
		p1.trainHorse(h3);
	}

}
