import helpers.PersonType;

import java.util.Vector;

public class Person {
	private static int count = 0;
	
	private int id;
	private String name;
	private String surname;
	
	//Dziedziczenie overlapping i dynamic - realizacja za pomoc kompozycji
	private Rider rider;
	private Trainer trainer;
	
	public Person(String name, String surname, PersonType type){
		count++;
		this.id = count;
		setName(name);
		setSurname(surname);
		if(type == PersonType.RIDER){
			this.rider = new Rider(this);
			this.trainer = null;
		}
		else if(type == PersonType.TRAINER){
			this.rider = null;
			this.trainer = new Trainer(this);
		}
		else if(type == PersonType.RIDER_TRAINER){
			this.rider = new Rider(this);
			this.trainer = new Trainer(this);
		}
		else{
			this.rider = null;
			this.trainer = null;
		}
	}
	//Gettery i settery dla atrybutw
	public static int getCount(){
		return count;
	}
	public int getId() {
		return id;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getSurname() {
		return surname;
	}
	public void setSurname(String surname) {
		this.surname = surname;
	}
	
	//Obsuga dziedziczenia overlapping i dynamic
	public void becomeRider(){
		if(!isRider())
			this.rider = new Rider(this);
	}
	public void stopBeingRider(){
		if(isRider())
			this.rider = null;
	}
	public void becomeTrainer(){
		if(!isTrainer())
		this.trainer = new Trainer(this);
	}
	public void stopBeingTrainer(){
		if(isTrainer()){
			this.trainer = null;
		}
	}
	public boolean isRider(){
		if(this.rider == null)
			return false;
		return true;
	}
	public boolean isTrainer(){
		if(this.trainer == null)
			return false;
		return true;
	}
	public void rideHorse(Horse horse){
		if(isRider())
			this.rider.rideHorse(horse);
	}
	public boolean addHorseToRide(Horse horse){
		if(isRider()){
			this.rider.addHorse(horse);
			return true;
		}
		return false;
	}
	public Vector<Horse> getHorsesToRide(){
		if(isRider())
			return this.rider.getHorses();
		return null;
	}
	public void trainHorse(Horse horse){
		if(isTrainer())
			this.trainer.trainHorse(horse);
	}
	public boolean addHorseToTrain(Horse horse){
		if(isTrainer()){
			this.trainer.addHorse(horse);
			return true;
		}
		return false;
	}
	public Vector<Horse> getHorsesToTrain(){
		if(isTrainer())
			return this.trainer.getHorses();
		return null;
	}
}
