import java.util.Calendar;

import helpers.*;

public class Main {

	public static void main(String[] args) {
		//Tworzenie przykadowych koni
		Horse h1 = new Horse("Hirsa");
		Horse h2 = new Horse("Broadway");
		Horse h3 = new Horse("Juka");

		//Tworzenie przykadowych osb w rolach jedca lub trenera
		//ograniczenie {xor} - osoba jest albo jedcem, albo trenerem - Enum PersonType
		//ograniczenie {unique} - pesel musi by unikalny
		//ograniczenie atrybutu wasne - pesel musi mie dugo 11 znakw
		Person p1 = new Person("95050511111", "Arthur", "Penhaligon", PersonType.RIDER); //{xor}
		Person p2 = new Person("97041223456", "Suzy", "Turquoise", PersonType.COACH);//{xor}
		Person p3, p4, p5;
		try{
			p3 = new Person("95050511111", "Arthur", "Clarke", PersonType.RIDER);
		} catch(NotUniqueValueException e){
			System.out.println("Person p3: Pesel nie jest unikalny!"); //{unique}
		}
		try{
			p4 = new Person("94033187", "Cho", "Kyuhyun", PersonType.RIDER);
		} catch(WrongFormatException e){
			System.out.println("Person p4: Zy format peselu!"); //wasne
		}
		p3 = new Person("17121635353", "Arthur", "Clarke", PersonType.COACH);
		p4 = new Person("94010199999", "Artemis", "Fowl", PersonType.RIDER);
		p5 = new Person("90013175758", "Lucy", "Pevensie", PersonType.RIDER);
		
		//Tworzenie przykadowych grup
		//ograniczenie {unique} - nazwa grupy musi by unikalna
		Group g1 = new Group("Bkitna");
		Group g2;
		try{
			g2 = new Group("Bkitna");
		} catch(NotUniqueValueException e){
			System.out.println("Group g2: Nazwa grupy nie jest unikalna!");
		}
		g2 = new Group("Szmaragdowa");
		
		//Asocjacja jedziec - konie, na ktrych jedzi
		//ograniczenie {ordered} - lista koni w kolejnoci dodania
		p1.getRider().addHorse(h2);
		p1.getRider().addHorse(h1);
		p4.getRider().addHorse(h3);
		p5.getRider().addHorse(h1);
		System.out.println(p1.toString());
		for(Horse h : p1.getRider().getHorsesRidden())
			System.out.println(h.getName());
		
		//Asocjacja z atrybutem trener - grupa
		//ograniczenie {bag} - wiele powiza tego samego trenera z t sam grup w innych terminach
		g1.addCoach(p2.getCoach());
		p3.getCoach().addGroup(g2);
		Calendar c = Calendar.getInstance();
		c.set(Calendar.MONTH, 8);
		g2.addCoach(p3.getCoach(), c);
		
		//Asocjacja grupa - czonek grupy i asocjacja grupa - lider grupy
		//ograniczenie {subset} - lider grupy musi nalee do tej grupy
		p1.getRider().addToGroup(g1);
		p4.getRider().addToGroup(g1);
		g2.addRider(p4.getRider());
		try{
			g1.setLeader(p5.getRider());
		} catch(Exception e){
			System.out.println(e);
		}
		try{
			g1.setLeader(p4.getRider());
		} catch(Exception e){
			e.printStackTrace();
		}
		
		
		//Ograniczenie dynamiczne atrybutu - poziom dowiadczenia jedca
		System.out.println(p1.toString() + ": poziom dowiadczenia = " + p1.getRider().getExperienceLevel());
		try{
			p1.getRider().setExperienceLevel(5);
			System.out.println(p1.toString() + ": poziom dowiadczenia = " + p1.getRider().getExperienceLevel());
			p1.getRider().setExperienceLevel(2);
			System.out.println(p1.toString() + ": poziom dowiadczenia = " + p1.getRider().getExperienceLevel());
		} catch (Exception e){
			System.out.println(e);
		}
		
	}

}
