import helpers.NotUniqueValueException;
import helpers.WrongFormatException;

import java.util.Set;
import java.util.HashSet;


public class Person {
	private Long id;
	private String pesel;
	private String name;
	private String surname;;
	
	private static Set<String> pesels = new HashSet<String>();
	
	//Konstruktor
	public Person(){}
	public Person(String pesel, String name, String surname) throws RuntimeException{
		setPesel(pesel);
		setName(name);
		setSurname(surname);
	}
	
	//Gettery i settery atrybutw
	public Long getId() {
		return id;
	}
	public void setId(Long id) {
		this.id = id;
	}

	public String getPesel() {
		return pesel;
	}
	public void setPesel(String pesel) throws NotUniqueValueException, WrongFormatException {
		if(peselUsed(pesel))
			throw new NotUniqueValueException();
		else if(!pesel.matches("\\d{11}"))
			throw new WrongFormatException();
		else{
			this.pesel = pesel;
			pesels.add(pesel);
		}
			
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getSurname() {
		return surname;
	}
	public void setSurname(String surname) {
		this.surname = surname;
	}
	
	private static boolean peselUsed(String pesel){
		return pesels.contains(pesel);
	}
	
	public String toString(){
		return getName() + " " + getSurname() + " o peselu " + getPesel();
	}
}
