import org.hibernate.Session;
import org.hibernate.Transaction;

import helpers.*;

import java.util.Set;
import java.util.HashSet;

public class Test {

	private String defaultPesel = "99887712345";
	private int i = 0;
	
	public static void main(String[] args) {
		System.out.println("Starting test");
		Test test = new Test();
		Horse horse1, horse2;
		horse1 = test.createAndStoreHorse("Hatatitla"); //Zapisywanie obiektu klasy Horse do bazy danych
		horse2 = test.createAndStoreHorse("Broadway");
		Set<Horse> horses = new HashSet<Horse>();
		horses.add(horse1);
		horses.add(horse2);
		
		/* Dziedziczenie zrealizowane przy pomocy asocjacji: Person <- Rider; Person <- Trainer */
		
		test.createAndStorePerson("90111123456", "Lirael", "Clayr");
		
		test.createAndStoreRider("88020376342", "Arthur", "Penhaligon");
		test.createAndStoreRider("93123187654", "Suzy", "Turquoise", horses); /* Asocjacja Rider -- Horse */
		
		test.createAndStoreTrainer("88121299999", "Neil", "Gaiman");
		test.createAndStoreTrainer("77061723232", "Garth", "Nix", horses); /* Asocjacja Trainer -- Horse */
		
		HibernateUtil.getSessionFactory().close();
	}

	private Horse createAndStoreHorse(String name) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		if(!session.isOpen())
			session = HibernateUtil.getSessionFactory().openSession();
		session.beginTransaction();
		
		Horse horse = new Horse();
		horse.setName(name);
		
		session.save(horse);
		session.getTransaction().commit();
		System.out.println("Ko dodany do bazy danych");
		return horse;
	}
	private void createAndStoreRider(String pesel, String name, String surname){
		Person person = createAndStorePerson(pesel, name, surname);

		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		if(!session.isOpen())
			session = HibernateUtil.getSessionFactory().openSession();
		session.beginTransaction();
		
		Rider rider = new Rider();
		rider.setPerson(person);
		
		session.save(rider);
		session.getTransaction().commit();
		System.out.println("Jedziec dodany do bazy danych");
	}
	private void createAndStoreRider(String pesel, String name, String surname, Set<Horse> horses){
		Person person = createAndStorePerson(pesel, name, surname);

		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		if(!session.isOpen())
			session = HibernateUtil.getSessionFactory().openSession();
		session.beginTransaction();
		
		Rider rider = new Rider();
		rider.setPerson(person);
		
		session.save(rider);
		session.getTransaction().commit();
		System.out.println("Jedziec dodany do bazy danych");
	}
	private void createAndStoreTrainer(String pesel, String name, String surname){
		Person person = createAndStorePerson(pesel, name, surname);
		
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		if(!session.isOpen())
			session = HibernateUtil.getSessionFactory().openSession();
		session.beginTransaction();
		
		Trainer trainer = new Trainer();
		trainer.setPerson(person);
		
		session.save(trainer);
		session.getTransaction().commit();
		System.out.println("Trener dodany do bazy danych");
	}
	private void createAndStoreTrainer(String pesel, String name, String surname, Set<Horse> horses){
		Person person = createAndStorePerson(pesel, name, surname);
		
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		if(!session.isOpen())
			session = HibernateUtil.getSessionFactory().openSession();
		session.beginTransaction();
		
		Trainer trainer = new Trainer();
		trainer.setPerson(person);
		trainer.setHorses(horses);
		
		session.save(trainer);
		session.getTransaction().commit();
		System.out.println("Trener dodany do bazy danych");
	}
	
	private Person createAndStorePerson(String pesel, String name, String surname){
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		if(!session.isOpen())
			session = HibernateUtil.getSessionFactory().openSession();
		session.beginTransaction();
		
		Person person = new Person();
		person.setPesel(pesel);
		person.setName(name);
		person.setSurname(surname);
		
		session.save(person);
		session.flush();
		session.getTransaction().commit();
		System.out.println("Osoba dodana do bazy danych");
				
		return person;
	}

}