import java.util.Set;
import java.util.HashSet;
import helpers.PartWithoutWholeException;

public class Trainer {

	private Long id;
	private Person person; //Kompozycja
	private Set<Horse> horses; //Asocjacja
	
	public Trainer(){
		horses = new HashSet<Horse>();
	}
	
	public Trainer(Person person) throws PartWithoutWholeException {
		setPerson(person);
		horses = new HashSet<Horse>();
	}
	
	//Gettery i settery atrybutw
	public Long getId() {
		return id;
	}

	private void setId(Long id) {
		this.id = id;
	}
	
	public Person getPerson(){
		return person;
	}
	public void setPerson(Person person) throws PartWithoutWholeException {
		if(person == null)
			throw new PartWithoutWholeException();
		this.person = person;
	}
	public Set<Horse> getHorses(){
		return this.horses;
	}
	public void setHorses(Set<Horse> horses){
		this.horses = horses;
	}
	
	
	public String toString(){
		StringBuffer buffer = new StringBuffer("Trener ");
		buffer.append(person.getName() + " " + person.getSurname());
		buffer.append(" o peselu " + person.getPesel() + ".\n");
		if(getHorses().size() == 0)
			buffer.append("Nie trenuje jeszcze adnego konia ze stajni.\n");
		else{
			buffer.append("Trenuje nastpujce konie:\n");
			for(Horse horse : getHorses())
				buffer.append(horse.getName());
			buffer.append("\n");
		}
		return buffer.toString();
	}

	

}
